import type { Either } from '@lokalise/node-core';
import type { QueueConsumer, MonoSchemaQueueOptions, BarrierResult } from '@message-queue-toolkit/core';
import type { ZodSchema } from 'zod';
import type { ExistingAMQPConsumerOptions, NewAMQPConsumerOptions } from './AbstractAmqpBaseConsumer';
import { AbstractAmqpBaseConsumer } from './AbstractAmqpBaseConsumer';
import type { AMQPConsumerDependencies } from './AbstractAmqpService';
export declare abstract class AbstractAmqpConsumerMonoSchema<MessagePayloadType extends object, BarrierOutput = undefined> extends AbstractAmqpBaseConsumer<MessagePayloadType, BarrierOutput> implements QueueConsumer {
    private readonly messageSchema;
    private readonly schemaEither;
    constructor(dependencies: AMQPConsumerDependencies, options: (NewAMQPConsumerOptions & MonoSchemaQueueOptions<MessagePayloadType>) | (ExistingAMQPConsumerOptions & MonoSchemaQueueOptions<MessagePayloadType>));
    protected resolveSchema(_message: MessagePayloadType): Either<Error, ZodSchema<MessagePayloadType, import("zod").ZodTypeDef, MessagePayloadType>>;
    /**
     * Override to implement barrier pattern
     */
    protected preHandlerBarrier(_message: MessagePayloadType): Promise<BarrierResult<BarrierOutput>>;
}
